#include <stdlib.h>

/* Not sure whether we really want this constness??? */
#define	__UNCONST(p)	((void *)(unsigned long)(const void *)(p))

long
strtol(const char *__restrict__ arg, char **__restrict__ end, int base)
{
    long l = 0;
    int sign = 1;
    int dig, found = 0;
    const char *cp = arg;

    /* Use isspace here? */
    while (*cp == ' ' || *cp == '\t' || *cp == '\n')
	cp++;

    if (*cp == '-') {
	cp++;
	sign = -1;
    } else if (*cp == '+')
	cp++;

    if (base == 0) {
	if (*cp == '0')
	    if (cp[1] == 'x') {
		base = 16;
		cp += 2;
	    } else
		base = 8;
	else
	    base = 10;
    }

    while (1) {
	if (*cp >= '0' && *cp <= '9')
	    dig = *cp++ - '0';
	else if (*cp >= 'a' && *cp <= 'f')
	    dig = *cp++ - 'a' + 10;
	else if (*cp >= 'A' && *cp <= 'F')
	    dig = *cp++ - 'A' + 10;
	else
	    break;
	if (dig < base) {
	    found = 1;
	    l = l * base + dig;
	} else {
	    cp--;
	    break;
	}
    }

    if (end) {
	if (found)
	    *end = __UNCONST(cp);
	else
	    *end = __UNCONST(arg);
    }

    return sign * l;
}

long
atol(const char *cp)
{
    return strtol(cp, 0, 10);
}

int
atoi(const char *cp)
{
    return (int)atol(cp);
}
